#ifndef CMDMANAGER_H
#define CMDMANAGER_H

#include "qmlhandler.h"

#include <json/json.h>

#include <map>
#include <string>
#include <vector>

struct fileEntry {
	bool dirty;
	std::string type;
	std::string method;
	int progress;
	float speed;
};

namespace CmdManager {
void init();
void setQmlHandler(QMLHandler *q);

void updateInternalFile(std::string name, std::string type, std::string method, int progress, float speed);
void emitFileList();
void cleanInternalList();

void executeCmd(std::string cmd, Json::Value root);

void handleError(Json::Value root);
void handleStatus(Json::Value root);
void handleClose(Json::Value root);
void handleList(Json::Value root);
void handleExtendedList(Json::Value root);
void handleConnect(Json::Value root);
void handleVersion(Json::Value root);
void handleLogin(Json::Value root);
void handleSignup(Json::Value root);
void handlePut(Json::Value root);
void handlePutData(Json::Value root);
void handleGet(Json::Value root);
void handleGetData(Json::Value root);
void handleDeleteMe(Json::Value root);
void handleDeleteFile(Json::Value root);
void handleNotifications(Json::Value root);
void handleQueue(Json::Value root);
void handleDequeue(Json::Value root);
void handleExtendedStatus(Json::Value root);
} // namespace CmdManager

#endif // CMDMANAGER_H
